"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var observable_array_1 = require("tns-core-modules/data/observable-array/observable-array");
var view_1 = require("tns-core-modules/ui/core/view");
var weak_event_listener_1 = require("tns-core-modules/ui/core/weak-event-listener/weak-event-listener");
var grid_layout_1 = require("tns-core-modules/ui/layouts/grid-layout");
var stack_layout_1 = require("tns-core-modules/ui/layouts/stack-layout");
var types_1 = require("tns-core-modules/utils/types");
var builder_1 = require("tns-core-modules/ui/builder");
var CardStackUtil = (function () {
    function CardStackUtil() {
    }
    CardStackUtil.debug = false;
    return CardStackUtil;
}());
exports.CardStackUtil = CardStackUtil;
var CLogTypes;
(function (CLogTypes) {
    CLogTypes[CLogTypes["info"] = 0] = "info";
    CLogTypes[CLogTypes["warning"] = 1] = "warning";
    CLogTypes[CLogTypes["error"] = 2] = "error";
})(CLogTypes = exports.CLogTypes || (exports.CLogTypes = {}));
exports.ITEMLOADING = 'itemLoading';
exports.CLog = function (type) {
    if (type === void 0) { type = 0; }
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    if (CardStackUtil.debug) {
        if (type === 0) {
            console.log('NativeScript-CardStack: INFO', args);
        }
        else if (type === 1) {
            console.log('NativeScript-CardStack: WARNING', args);
        }
        else if (type === 2) {
            console.log('NativeScript-CardStack: ERROR', args);
        }
    }
};
var CardStackCommon = (function (_super) {
    __extends(CardStackCommon, _super);
    function CardStackCommon() {
        var _this = _super.call(this) || this;
        _this.views = [];
        _this.visibleCount = 3;
        _this.selectedIndex = 0;
        return _this;
    }
    Object.defineProperty(CardStackCommon.prototype, "debug", {
        set: function (value) {
            CardStackUtil.debug = value;
        },
        enumerable: true,
        configurable: true
    });
    CardStackCommon.prototype._createTemplateView = function () {
        var view = builder_1.parse(this.itemTemplate, this);
        this.views.push(view);
        this.addChild(view);
        return view;
    };
    CardStackCommon.draggingEvent = 'dragging';
    CardStackCommon.swipedEvent = 'swiped';
    CardStackCommon.canceledEvent = 'canceled';
    CardStackCommon.rewoundEvent = 'rewound';
    CardStackCommon.loadedEvent = 'loaded';
    CardStackCommon.disappearedEvent = 'disappeared';
    CardStackCommon.appearedEvent = 'appeared';
    return CardStackCommon;
}(grid_layout_1.GridLayout));
exports.CardStackCommon = CardStackCommon;
var CardStackItem = (function (_super) {
    __extends(CardStackItem, _super);
    function CardStackItem() {
        var _this = _super.call(this) || this;
        exports.CLog(CLogTypes.info, "CardStackItem constructor...");
        return _this;
    }
    CardStackItem.prototype.onLoaded = function () {
        _super.prototype.onLoaded.call(this);
    };
    return CardStackItem;
}(stack_layout_1.StackLayout));
exports.CardStackItem = CardStackItem;
var knownMultiTemplates;
(function (knownMultiTemplates) {
    knownMultiTemplates.itemTemplates = 'itemTemplates';
})(knownMultiTemplates = exports.knownMultiTemplates || (exports.knownMultiTemplates = {}));
var knownCollections;
(function (knownCollections) {
    knownCollections.items = 'items';
})(knownCollections = exports.knownCollections || (exports.knownCollections = {}));
var knownTemplates;
(function (knownTemplates) {
    knownTemplates.itemTemplate = 'itemTemplate';
})(knownTemplates = exports.knownTemplates || (exports.knownTemplates = {}));
exports.itemTemplateProperty = new view_1.Property({
    name: 'itemTemplate',
    affectsLayout: true,
    valueChanged: function (view, oldValue, newValue) {
        view.refresh(true);
    }
});
exports.itemTemplateProperty.register(CardStackCommon);
exports.itemsProperty = new view_1.Property({
    name: 'items',
    affectsLayout: true,
    valueChanged: onItemsChanged
});
exports.itemsProperty.register(CardStackCommon);
exports.optionsProperty = new view_1.Property({
    name: 'options',
    valueChanged: function () {
    }
});
exports.optionsProperty.register(CardStackCommon);
exports.selectedIndexProperty = new view_1.Property({
    name: 'selectedIndex',
    defaultValue: 0,
    valueConverter: function (value) {
        return +value;
    },
    valueChanged: function (view, oldValue, newValue) {
        view.selectedIndex = newValue;
    }
});
exports.selectedIndexProperty.register(CardStackCommon);
function onItemsChanged(view, oldValue, newValue) {
    if (oldValue instanceof observable_array_1.ObservableArray) {
        weak_event_listener_1.removeWeakEventListener(oldValue, observable_array_1.ObservableArray.changeEvent, view.refresh, view);
    }
    if (newValue instanceof observable_array_1.ObservableArray) {
        weak_event_listener_1.addWeakEventListener(newValue, observable_array_1.ObservableArray.changeEvent, view.refresh, view);
    }
    if (!types_1.isNullOrUndefined(view.items) && types_1.isNumber(view.items.length)) {
        view.refresh(false);
    }
}
//# sourceMappingURL=index.common.js.map